package com.tencent.qqmusictv.network.unifiedcgi.response.loginresponse

import android.os.Parcel
import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import com.tencent.qqmusictv.common.model.BaseInfo

/**
 * Copyright (C) 1998 - 2018 TENCENT Inc.All Rights Reserved.
 * @Title : trunkNew
 * @Description:
 * @Author : alexyjhan
 * @Data : 2018/5/3 11 : 03
 */


data class LoginResponseRoot(
        @SerializedName("BasicinfoServer") val basicinfoServer: BasicinfoServer,
        val code: Int,
        val ts: Long
) : BaseInfo(), Parcelable {
    constructor(source: Parcel) : this(
            source.readParcelable<BasicinfoServer>(BasicinfoServer::class.java.classLoader),
            source.readInt(),
            source.readLong()
    )

    override fun describeContents() = 0

    override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
        writeParcelable(basicinfoServer, 0)
        writeInt(code)
        writeLong(ts)
    }

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<LoginResponseRoot> = object : Parcelable.Creator<LoginResponseRoot> {
            override fun createFromParcel(source: Parcel): LoginResponseRoot = LoginResponseRoot(source)
            override fun newArray(size: Int): Array<LoginResponseRoot?> = arrayOfNulls(size)
        }
    }
}

data class BasicinfoServer(
        val data: Data,
        val code: Int
) : Parcelable {
    constructor(source: Parcel) : this(
            source.readParcelable<Data>(Data::class.java.classLoader),
            source.readInt()
    )

    override fun describeContents() = 0

    override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
        writeParcelable(data, 0)
        writeInt(code)
    }

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<BasicinfoServer> = object : Parcelable.Creator<BasicinfoServer> {
            override fun createFromParcel(source: Parcel): BasicinfoServer = BasicinfoServer(source)
            override fun newArray(size: Int): Array<BasicinfoServer?> = arrayOfNulls(size)
        }
    }
}

data class Data(
        val encrypt_uin: String,
        val errortip: String,
        val face: String,
        val feedbackurl: String,
        val name: String,
        val subcode: Int,
        val userip: String,
        val code: Int,
        val gray: Int
) : Parcelable {
    constructor(source: Parcel) : this(
            source.readString(),
            source.readString(),
            source.readString(),
            source.readString(),
            source.readString(),
            source.readInt(),
            source.readString(),
            source.readInt(),
            source.readInt()
    )

    override fun describeContents() = 0

    override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
        writeString(encrypt_uin)
        writeString(errortip)
        writeString(face)
        writeString(feedbackurl)
        writeString(name)
        writeInt(subcode)
        writeString(userip)
        writeInt(code)
        writeInt(gray)
    }

    companion object {
        @JvmField
        val CREATOR: Parcelable.Creator<Data> = object : Parcelable.Creator<Data> {
            override fun createFromParcel(source: Parcel): Data = Data(source)
            override fun newArray(size: Int): Array<Data?> = arrayOfNulls(size)
        }
    }
}