package com.tencent.qqmusictv.network.unifiedcgi.response.loginvipresponse

import android.os.Parcel
import android.os.Parcelable
import com.google.gson.annotations.SerializedName
import com.tencent.qqmusictv.common.model.BaseInfo

/**
 * Copyright (C) 1998 - 2018 TENCENT Inc.All Rights Reserved.
 * @Title : trunkNew
 * @Description:
 * @Author : alexyjhan
 * @Data : 2018/4/20 10 : 59
 */


data class LoginVipResponseRoot(
		@SerializedName("VipLogin") val vipLogin: VipLogin,
		val code: Int,
		val ts: Long
) : BaseInfo(), Parcelable {
	constructor(source: Parcel) : this(
			source.readParcelable<VipLogin>(VipLogin::class.java.classLoader),
			source.readInt(),
			source.readLong()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeParcelable(vipLogin, 0)
		writeInt(code)
		writeLong(ts)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<LoginVipResponseRoot> = object : Parcelable.Creator<LoginVipResponseRoot> {
			override fun createFromParcel(source: Parcel): LoginVipResponseRoot = LoginVipResponseRoot(source)
			override fun newArray(size: Int): Array<LoginVipResponseRoot?> = arrayOfNulls(size)
		}
	}
}

data class VipLogin(
		val data: Data,
		val code: Int
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readParcelable<Data>(Data::class.java.classLoader),
			source.readInt()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeParcelable(data, 0)
		writeInt(code)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<VipLogin> = object : Parcelable.Creator<VipLogin> {
			override fun createFromParcel(source: Parcel): VipLogin = VipLogin(source)
			override fun newArray(size: Int): Array<VipLogin?> = arrayOfNulls(size)
		}
	}
}

data class Data(
		val alteraidlist: Alteraidlist,
		val alterlist: Alterlist,
		val autodown: Int,
		val canRenew: Int,
		val cmax: Int,
		val global_dtsconfig: GlobalDtsconfig,
		val gmax: Int,
		val grayuin: Int,
		val highdown: Int,
		val identity: Identity,
		val maxdirnum: Int,
		val maxsongnum: Int,
		val music_lev_hq: Int,
		val music_lev_sq: Int,
		val mygreen: String,
		val offeridflag: Int,
		val paydown: Int,
		val pdl: Int,
		val pneed: Int,
		val pneedbuy: Int,
		val premain: Int,
		val send: String,
		val showLimitUrl: String,
		val showlimit: Int,
		val smax: Int,
		val song_limit_msg: String,
		val song_limit_url: String,
		val sstart: String,
		val star: Int,
		val starend: String,
		val starstart: String,
		val svip: Int,
		val user_dtsconfig: UserDtsconfig,
		val userinfo: Userinfo,
		val ystar: Int,
		val ystarend: String,
		val ystarstart: String
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readParcelable<Alteraidlist>(Alteraidlist::class.java.classLoader),
			source.readParcelable<Alterlist>(Alterlist::class.java.classLoader),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readParcelable<GlobalDtsconfig>(GlobalDtsconfig::class.java.classLoader),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readParcelable<Identity>(Identity::class.java.classLoader),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readParcelable<UserDtsconfig>(UserDtsconfig::class.java.classLoader),
			source.readParcelable<Userinfo>(Userinfo::class.java.classLoader),
			source.readInt(),
			source.readString(),
			source.readString()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeParcelable(alteraidlist, 0)
		writeParcelable(alterlist, 0)
		writeInt(autodown)
		writeInt(canRenew)
		writeInt(cmax)
		writeParcelable(global_dtsconfig, 0)
		writeInt(gmax)
		writeInt(grayuin)
		writeInt(highdown)
		writeParcelable(identity, 0)
		writeInt(maxdirnum)
		writeInt(maxsongnum)
		writeInt(music_lev_hq)
		writeInt(music_lev_sq)
		writeString(mygreen)
		writeInt(offeridflag)
		writeInt(paydown)
		writeInt(pdl)
		writeInt(pneed)
		writeInt(pneedbuy)
		writeInt(premain)
		writeString(send)
		writeString(showLimitUrl)
		writeInt(showlimit)
		writeInt(smax)
		writeString(song_limit_msg)
		writeString(song_limit_url)
		writeString(sstart)
		writeInt(star)
		writeString(starend)
		writeString(starstart)
		writeInt(svip)
		writeParcelable(user_dtsconfig, 0)
		writeParcelable(userinfo, 0)
		writeInt(ystar)
		writeString(ystarend)
		writeString(ystarstart)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<Data> = object : Parcelable.Creator<Data> {
			override fun createFromParcel(source: Parcel): Data = Data(source)
			override fun newArray(size: Int): Array<Data?> = arrayOfNulls(size)
		}
	}
}

/**
 * TODO 这个后台文档返回为空，只能先把data去掉了
 */
class Alteraidlist(
) : Parcelable {
	constructor(source: Parcel) : this(
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<Alteraidlist> = object : Parcelable.Creator<Alteraidlist> {
			override fun createFromParcel(source: Parcel): Alteraidlist = Alteraidlist(source)
			override fun newArray(size: Int): Array<Alteraidlist?> = arrayOfNulls(size)
		}
	}
}

data class Alterlist(
		val download_sq: String,
		val gdt_ad: String,
		val listen_hq_nowifi: String,
		val listen_hq_wifi: String,
		val listen_sq_nowifi: String,
		val listen_sq_wifi: String,
		val mv_ad: String,
		val player_actionsheert_setbgmusic: String,
		val songlist_actionsheet_setbgmusic: String,
		val songlist_multiselect_setbgmusic: String
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeString(download_sq)
		writeString(gdt_ad)
		writeString(listen_hq_nowifi)
		writeString(listen_hq_wifi)
		writeString(listen_sq_nowifi)
		writeString(listen_sq_wifi)
		writeString(mv_ad)
		writeString(player_actionsheert_setbgmusic)
		writeString(songlist_actionsheet_setbgmusic)
		writeString(songlist_multiselect_setbgmusic)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<Alterlist> = object : Parcelable.Creator<Alterlist> {
			override fun createFromParcel(source: Parcel): Alterlist = Alterlist(source)
			override fun newArray(size: Int): Array<Alterlist?> = arrayOfNulls(size)
		}
	}
}

data class GlobalDtsconfig(
		val can_trial: Int,
		val expiration: Int
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readInt(),
			source.readInt()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeInt(can_trial)
		writeInt(expiration)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<GlobalDtsconfig> = object : Parcelable.Creator<GlobalDtsconfig> {
			override fun createFromParcel(source: Parcel): GlobalDtsconfig = GlobalDtsconfig(source)
			override fun newArray(size: Int): Array<GlobalDtsconfig?> = arrayOfNulls(size)
		}
	}
}

data class Userinfo(
		val buyurl: String,
		val context: String,
		val expire: Int,
		val expireid: Int,
		val music_level: Int,
		val music_level_url: String,
		val myvipurl: String,
		val radio: Int,
		val score: Int,
		val tipsicon: String,
		val vecIcon: List<VecIcon>
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.createTypedArrayList(VecIcon.CREATOR)
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeString(buyurl)
		writeString(context)
		writeInt(expire)
		writeInt(expireid)
		writeInt(music_level)
		writeString(music_level_url)
		writeString(myvipurl)
		writeInt(radio)
		writeInt(score)
		writeString(tipsicon)
		writeTypedList(vecIcon)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<Userinfo> = object : Parcelable.Creator<Userinfo> {
			override fun createFromParcel(source: Parcel): Userinfo = Userinfo(source)
			override fun newArray(size: Int): Array<Userinfo?> = arrayOfNulls(size)
		}
	}
}

data class VecIcon(
		val aidid: Int,
		val id: Int,
		val pic: String,
		val size: String
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readString()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeInt(aidid)
		writeInt(id)
		writeString(pic)
		writeString(size)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<VecIcon> = object : Parcelable.Creator<VecIcon> {
			override fun createFromParcel(source: Parcel): VecIcon = VecIcon(source)
			override fun newArray(size: Int): Array<VecIcon?> = arrayOfNulls(size)
		}
	}
}

data class Identity(
		val androidurl: String,
		val btn_flag: Int,
		val btn_msg: String,
		val btn_url: String,
		val cuifei: Int,
		val debugmsg: String,
		val eight: Int,
		val eightEnd: String,
		val eightStart: String,
		val icon: String,
		val level: Int,
		val nextlevel: Int,
		val overdate: String,
		val payType: Int,
		val payway: Int,
		val paywaydetail: String,
		val punlimit: Int,
		val purchaseCode: String,
		val purchaseMonth: String,
		val purchaseType: String,
		val purchaseUrl: String,
		val strEightIapUrl: String,
		val strTwelveIapUrl: String,
		val twelve: Int,
		val twelveEnd: String,
		val twelveStart: String,
		val upgradeday: Int,
		val upgradepct: Double,
		val vendor: String,
		val vip: Int,
		val weixinflag: Int,
		val yearffb: Int,
		val yearflag: Int
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readString(),
			source.readString(),
			source.readInt(),
			source.readDouble(),
			source.readString(),
			source.readInt(),
			source.readInt(),
			source.readInt(),
			source.readInt()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeString(androidurl)
		writeInt(btn_flag)
		writeString(btn_msg)
		writeString(btn_url)
		writeInt(cuifei)
		writeString(debugmsg)
		writeInt(eight)
		writeString(eightEnd)
		writeString(eightStart)
		writeString(icon)
		writeInt(level)
		writeInt(nextlevel)
		writeString(overdate)
		writeInt(payType)
		writeInt(payway)
		writeString(paywaydetail)
		writeInt(punlimit)
		writeString(purchaseCode)
		writeString(purchaseMonth)
		writeString(purchaseType)
		writeString(purchaseUrl)
		writeString(strEightIapUrl)
		writeString(strTwelveIapUrl)
		writeInt(twelve)
		writeString(twelveEnd)
		writeString(twelveStart)
		writeInt(upgradeday)
		writeDouble(upgradepct)
		writeString(vendor)
		writeInt(vip)
		writeInt(weixinflag)
		writeInt(yearffb)
		writeInt(yearflag)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<Identity> = object : Parcelable.Creator<Identity> {
			override fun createFromParcel(source: Parcel): Identity = Identity(source)
			override fun newArray(size: Int): Array<Identity?> = arrayOfNulls(size)
		}
	}
}

data class UserDtsconfig(
		val can_trial: Int,
		val expiration: Int
) : Parcelable {
	constructor(source: Parcel) : this(
			source.readInt(),
			source.readInt()
	)

	override fun describeContents() = 0

	override fun writeToParcel(dest: Parcel, flags: Int) = with(dest) {
		writeInt(can_trial)
		writeInt(expiration)
	}

	companion object {
		@JvmField
		val CREATOR: Parcelable.Creator<UserDtsconfig> = object : Parcelable.Creator<UserDtsconfig> {
			override fun createFromParcel(source: Parcel): UserDtsconfig = UserDtsconfig(source)
			override fun newArray(size: Int): Array<UserDtsconfig?> = arrayOfNulls(size)
		}
	}
}